unit Frm_nastav;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Db, DBTables, ExtCtrls;

type
  TComponentTypes = (ctSystem, ctEdit, ctCheckBox, ctRadioGroup, ctListBox);


  TFrmNastav = class(TFrame)
    btnUlozit: TButton;
    btnNacist: TButton;
    GroupBox1: TGroupBox;
    lbPocetInfo: TLabel;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    lbPocetInfoNum: TLabel;
    QueryNastav: TQuery;
    Timer1: TTimer;
    Label1: TLabel;
    lbDatLast: TLabel;
    procedure btnUlozitClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnNacistClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Uloz (fParentControl:TControl);
    procedure Nacti(fParentControl:TControl);
    procedure Nacti_db_System;

    procedure Nastav_db;
    procedure Uloz_db (typ:TComponentTypes;Nazev,Hodnota:string);
    procedure Uloz_db_DatLast;
    procedure Smaz_db;
    Function Count_db:integer;
  end;

implementation

{$R *.DFM}
procedure TFrmNastav.Uloz_db_DatLast;
begin
  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('INSERT INTO db_nastav (Typ,Nazev,Hodnota) VALUES (0,"DATLAST","'+FormatDateTime('dd.mm.yyyy hh:nn:ss',now)+'")');
    ExecSQL;
  except
    raise;
  end;
end;

procedure TFrmNastav.Uloz_db (typ:TComponentTypes;Nazev,Hodnota:string);
begin
  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('INSERT INTO db_nastav (Typ,Nazev,Hodnota) VALUES ('+IntToStr(Ord(Typ))+',"'+Nazev+'","'+Hodnota+'")');
    ExecSQL;
  except
    raise;
  end;
end;

Function TFrmNastav.Count_db:integer;
begin
  Result := -1;
  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('SELECT COUNT(*) FROM db_nastav');
    Open;
    Result := Fields[0].AsInteger;
    Close;
  except
    raise;
  end;
end;

procedure TFrmNastav.Nacti_db_System;
begin
  Nastav_db;
  lbPocetInfoNum.Caption := IntToStr(Count_db);

  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('SELECT Nazev,Hodnota FROM db_nastav');
    SQL.Add ('WHERE Typ = '+IntToSTr(Ord(ctSystem)));
    Open;
    while not EOF do
    begin
      if  FieldByName('Nazev').AsString='DATLAST' then
      begin
        lbDatLast.Caption := FieldByName('Hodnota').AsString;
      end;
      Next;
    end;
    Close;
  except
    raise;
  end;

end;

procedure TFrmNastav.Nacti(fParentControl:TControl);
var
 fComponent : TComponent;
begin
  Nastav_db;
  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('SELECT Typ,Nazev,Hodnota FROM db_nastav');
    SQL.Add ('WHERE Typ > '+IntToSTr(Ord(ctSystem)));
    Open;
    while not EOF do
    begin
      fComponent := fParentControl.FindComponent(FieldByName('Nazev').AsString);
      if Assigned(fComponent) then
        Case FieldByName('Typ').AsInteger of
          ord(ctEdit):
                (fComponent as TEdit).Text := FieldByName('Hodnota').AsString;
          ord(ctCheckBox):
                begin
                 if FieldByName('Hodnota').AsString = 'Y' then (fComponent as TCheckBox).Checked := True
                 else (fComponent as TCheckBox).Checked := False;
                end;
          ord(ctRadioGroup):
                (fComponent as TRadioGroup).ItemIndex := FieldByName('Hodnota').AsInteger;
          ord(ctListBox):
                (fComponent as TListBox).ItemIndex := FieldByName('Hodnota').AsInteger;
        end;
      Next;
    end;
    Close;
  except
    raise;
  end;
end;

procedure TFrmNastav.Smaz_db;
begin
  Nastav_db;
  with QueryNastav do
  try
    SQL.Clear;
    SQL.Add ('DELETE FROM db_nastav');
    ExecSQL;
  except
    raise;
  end;
end;

procedure TFrmNastav.Uloz (fParentControl:TControl);
var
  i: integer;
  s : STring;
begin
  Nastav_db;
  ProgressBar1.Max := ProgressBar1.Max + fParentControl.ComponentCount+1;
  For i := 0 to fParentControl.ComponentCount-1 do
  begin
    if fParentControl.Components[i] is TEdit then
    begin
      Uloz_db (ctEdit,fParentControl.Components[i].Name,(fParentControl.Components[i] as TEdit).Text);
    end;
    if fParentControl.Components[i] is TCheckBox then
    begin
      s := '';
      if (fParentControl.Components[i] as TCheckBox).Checked then s := 'Y'
      else s := 'N';
      Uloz_db (ctCheckBox,fParentControl.Components[i].Name,s);
    end;
    if fParentControl.Components[i] is TRadioGroup then
    begin
      Uloz_db (ctRadioGroup,fParentControl.Components[i].Name,
        IntToStr((fParentControl.Components[i] as TRadioGroup).ItemIndex));
    end;
    if fParentControl.Components[i] is TListBox then
    begin
      Uloz_db (ctListBox,fParentControl.Components[i].Name,
        IntToStr((fParentControl.Components[i] as TListBox).ItemIndex));
    end;
    ProgressBar1.StepIt;
    ProgressBar1.Refresh;
  end;
  Uloz_db_DatLast;
end;

procedure TFrmNastav.btnUlozitClick(Sender: TObject);
var
  pParent : TControl; // Promnn pro vlastnka Komponent
begin
  pParent := Parent;
  While not(pParent is TForm) do pParent := pParent.Parent;

  Timer1.OnTimer(Sender); // Nastav ProgressBar na poten hodnotu
  btnNacist.Enabled := False;
  try
    Smaz_db;
    Uloz(pParent);
    Nacti_db_System;
  finally
    btnNacist.Enabled := True;
    ProgressBar1.Position := ProgressBar1.Max;
    Timer1.Enabled := True;
  end;
end;

procedure TFrmNastav.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  ProgressBar1.Min := 0;
  ProgressBar1.Position := 0;
  ProgressBar1.Max := 0;
end;

procedure TFrmNastav.Nastav_db;
begin
  QueryNastav.DatabaseName := ExtractFilePath(Application.ExeName)+'db';
end;

procedure TFrmNastav.btnNacistClick(Sender: TObject);
var
  pParent : TControl; // Promnn pro vlastnka Komponent
begin
  pParent := Parent;
  While not(pParent is TForm) do pParent := pParent.Parent;

  Timer1.OnTimer(Sender); // Nastav ProgressBar na poten hodnotu
  btnUlozit.Enabled := False;
  try
    Nacti_db_System;
    Nacti(pParent);
  finally
    btnUlozit.Enabled := True;
    ProgressBar1.Position := ProgressBar1.Max;
    Timer1.Enabled := True;
  end;
end;

end.
